//*****************************************************************************************************
//  1. t@C
//		DigitalDataDlg.cpp
//----------------------------------------------------------------------------------------------------
//  2. @\
//		fW^l\_CAONX̎
//----------------------------------------------------------------------------------------------------
//  3. l
//----------------------------------------------------------------------------------------------------
//  4. 
//		2007.08.09 S.Aizawa VK쐬
//*****************************************************************************************************

#include "stdafx.h"
#include "MMA_G.h"
#include "DigitalDataDlg.h"
#include "TimeRangeDlg.h"
#include "General.h"

#define PAGE_SIZE	1000		// 1y[W̃f[^

// CDigitalDataDlg _CAO

IMPLEMENT_DYNAMIC(CDigitalDataDlg, CDialogEx)

//*****************************************************************************************************
//  1. ֐
//		CDigitalDataDlg::CDigitalDataDlg
//----------------------------------------------------------------------------------------------------
//  2. @\
//		RXgN^
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		CWnd		*pParent		[I] eEBhE|C^
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
CDigitalDataDlg::CDigitalDataDlg(CWnd *pParent)
	: CDialogEx(CDigitalDataDlg::IDD, pParent)
{
}

void CDigitalDataDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_LIST_DATA, m_cListData);
	DDX_Control(pDX, IDC_EDIT_PAGE_NO, m_cEditPageNo);
	DDX_Control(pDX, IDC_BUTTON_PREV_PAGE, m_cButtonPrevPage);
	DDX_Control(pDX, IDC_BUTTON_NEXT_PAGE, m_cButtonNextPage);
	DDX_Control(pDX, IDC_COMBO_SAMPLE_RATE, m_cComboSampleRate);
}


BEGIN_MESSAGE_MAP(CDigitalDataDlg, CDialogEx)
	ON_BN_CLICKED(IDC_BUTTON_PREV_PAGE, &CDigitalDataDlg::OnBnClickedButtonPrevPage)
	ON_BN_CLICKED(IDC_BUTTON_NEXT_PAGE, &CDigitalDataDlg::OnBnClickedButtonNextPage)
	ON_CBN_SELCHANGE(IDC_COMBO_SAMPLE_RATE, &CDigitalDataDlg::OnCbnSelchangeComboSampleRate)
	ON_BN_CLICKED(IDC_BUTTON_PRINT, &CDigitalDataDlg::OnBnClickedButtonPrint)
	ON_BN_CLICKED(IDC_BUTTON_SELECT_ALL, &CDigitalDataDlg::OnBnClickedButtonSelectAll)
	ON_WM_DESTROY()
END_MESSAGE_MAP()

// c[`bv\f[^
static const SToolTipData s_aToolTip[] = {
	{IDC_BUTTON_PREV_PAGE, "Oy[W̃f[^\܂B"},
	{IDC_BUTTON_NEXT_PAGE, "y[W̃f[^\܂B"},
	{IDC_BUTTON_SELECT_ALL, "Sf[^IĈł悤ɂ܂B"},
	{IDC_BUTTON_PRINT, "IĂf[^܂B"},
	{IDCANCEL, "̃_CAO܂B"},
	{0, NULL}
};

//*****************************************************************************************************
//  1. ֐
//		CDigitalDataDlg::DispList
//----------------------------------------------------------------------------------------------------
//  2. @\
//		Xg\
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		LPCTSTR		pFilePath		[I] t@C̃pX
//		int			nDataType		[I] f[^̎ށiMMA or MMEj
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CDigitalDataDlg::DispList(LPCTSTR pFilePath, int nDataType)
{
	// f[^(MMA or MME)ۑ
	m_cDataFile.m_nDataType = nDataType;

	// t@Cǂݍ
	if (!m_cDataFile.ReadInfoFile(pFilePath)) {
		delete this;
		return;
	}

	// Ԕ͈͐ݒ_CAO\
	CTimeRangeDlg cTimeRangeDlg;
	cTimeRangeDlg.m_dStarttime = m_cDataFile.m_dStarttime;
	cTimeRangeDlg.m_nDataSec = (int)m_cDataFile.m_fTotalSecond;
	cTimeRangeDlg.m_sKind = "lf[^";
	if (cTimeRangeDlg.DoModal() == IDCANCEL) {
		delete this;
		return;
	}

	// p[^ۑ
	m_sFilePath = pFilePath;
	m_nBeginTime = cTimeRangeDlg.m_nDispBegin;
	m_nEndTime = cTimeRangeDlg.m_nDispEnd;
	m_cDataFile.m_dInStarttime = cTimeRangeDlg.m_dInStarttime;
	m_cDataFile.m_dInEndtime = cTimeRangeDlg.m_dInEndtime;

	// f[^ǂݍ
	if (!m_cDataFile.ReadDataFile(m_nBeginTime, m_nEndTime, TRUE, TRUE, FALSE)) {
		delete this;
		return;
	}

	// _CAO\
	DoModeless();
}

//*****************************************************************************************************
//  1. ֐
//		CDigitalDataDlg::OnInitDialog
//----------------------------------------------------------------------------------------------------
//  2. @\
//		_CAO
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		BOOL		TRUE
//*****************************************************************************************************
BOOL CDigitalDataDlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// sŜIł悤ɂ
	m_cListData.SetExtendedStyle(LVS_EX_FULLROWSELECT);

	// Xgwb_ݒ
	SetListHeader();

	// f[^\
	DispData(1);

	// TvOg̃R{{bNXݒ
	CGeneral::SetSampleRateList(m_cComboSampleRate, m_cDataFile.m_fSampleRate);

	// Rg[̈ʒu𒲐
	SetCtlPosition(IDC_LIST_DATA, 0, 0, 1, 1);
	SetCtlPosition(IDC_STATIC_PAGE_CHANGE, 0, 1, 0, 1);
	SetCtlPosition(IDC_BUTTON_PREV_PAGE, 0, 1, 0, 1);
	SetCtlPosition(IDC_BUTTON_NEXT_PAGE, 0, 1, 0, 1);
	SetCtlPosition(IDC_STATIC_SAMPLE_RATE, 0, 1, 0, 1);
	SetCtlPosition(IDC_COMBO_SAMPLE_RATE, 0, 1, 0, 1);
	SetCtlPosition(IDC_EDIT_PAGE_NO, 0, 1, 0, 1);
	SetCtlPosition(IDC_STATIC_PRINT, 0, 1, 0, 1);
	SetCtlPosition(IDC_BUTTON_SELECT_ALL, 0, 1, 0, 1);
	SetCtlPosition(IDC_BUTTON_PRINT, 0, 1, 0, 1);
	SetCtlPosition(IDCANCEL, 1, 1, 1, 1);

	// c[`bv\ݒ
	CGeneral::SetToolTip(m_tooltip, s_aToolTip, this);

	return TRUE;
}

//*****************************************************************************************************
//  1. ֐
//		CDigitalDataDlg::SetListHeader
//----------------------------------------------------------------------------------------------------
//  2. @\
//		Xgwb_ݒ菈
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CDigitalDataDlg::SetListHeader()
{
	struct LIxxxOLUMN {
		char *pText;
		int fmt;
		int width;
	} tColumnDataMma[] = {
		{"No", LVCFMT_LEFT, 70},
// 077FD050-GYM961-0_002 2007/9/6 modified by yG ->
//		{"Time", LVCFMT_LEFT, 150},
		{"Time(YYYY/MM/DD hh:mm:ss.tttt)", LVCFMT_LEFT, 150},
// 077FD050-GYM961-0_002 2007/9/6 modified by yG <-
		{"X-Axis(g)", LVCFMT_LEFT, 90},
		{"Y-Axis(g)", LVCFMT_LEFT, 90},
		{"Z-Axis(g)", LVCFMT_LEFT, 90},
		{"D-Temp()", LVCFMT_LEFT, 75},
		{"X-Temp()", LVCFMT_LEFT, 75},
		{"Y-Temp()", LVCFMT_LEFT, 75},
		{"Z-Temp()", LVCFMT_LEFT, 75}
	}, tColumnDataMme[] = {
		{"No", LVCFMT_LEFT, 70},
		{"Time(YYYY/MM/DD hh:mm:ss.tttt)", LVCFMT_LEFT, 150},
		{"X-Axis(g)", LVCFMT_LEFT, 90},
		{"Y-Axis(g)", LVCFMT_LEFT, 90},
		{"Z-Axis(g)", LVCFMT_LEFT, 90},
	}, tColumnDataAsu[] = {
		{"No", LVCFMT_LEFT, 70},
		{"Time(YYYY/MM/DD hh:mm:ss.tttt)", LVCFMT_LEFT, 150},
		{"X-Axis(g)", LVCFMT_LEFT, 90},
		{"Y-Axis(g)", LVCFMT_LEFT, 90},
		{"Z-Axis(g)", LVCFMT_LEFT, 90},
	}, *pColumn;
	int i;
	int nColumn;
	LV_COLUMN lvc;

	// Jf[^
	switch (m_cDataFile.m_nDataType) {
	case DATA_TYPE_MMA:
		pColumn = tColumnDataMma;
		nColumn  = sizeof(tColumnDataMma) / sizeof(LIxxxOLUMN);
		break;
	case DATA_TYPE_MME:
		pColumn = tColumnDataMme;
		nColumn  = sizeof(tColumnDataMme) / sizeof(LIxxxOLUMN);
		break;
	case DATA_TYPE_ASU:
		pColumn = tColumnDataMme;
		nColumn  = sizeof(tColumnDataMme) / sizeof(LIxxxOLUMN);
		break;
	default:
		return;
	}

	// Jݒ
	for (i = 0; i < nColumn; i++) {
		lvc.mask = LVCF_FMT | LVCF_WIDTH | LVCF_TEXT;
		lvc.fmt = pColumn->fmt;
		lvc.pszText = pColumn->pText;
		lvc.cx = pColumn->width;
		m_cListData.InsertColumn(i, &lvc);
		pColumn++;
	}
}

//*****************************************************************************************************
//  1. ֐
//		CDigitalDataDlg::DispData
//----------------------------------------------------------------------------------------------------
//  2. @\
//		f[^\
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		int		nPageNo		[I] \y[Wԍ
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CDigitalDataDlg::DispData(int nPageNo)
{
	CString sText;

	// y[Wԍۑ
	m_nPageNo = nPageNo;

	// y[W擾
	m_nPageNum = (m_cDataFile.m_nDataSize / m_cDataFile.m_nDownRate + PAGE_SIZE - 1) / PAGE_SIZE;

	// ĕ`֎~
	m_cListData.SetRedraw(FALSE);

	// SẴf[^
	m_cListData.DeleteAllItems();

	// f[^̃CfbNX擾
	int nIndex = (nPageNo - 1) * PAGE_SIZE * m_cDataFile.m_nDownRate;

	// XgRg[Ƀf[^\
	for (int i = 0; i < PAGE_SIZE && nIndex < m_cDataFile.m_nDataSize; i++, nIndex += m_cDataFile.m_nDownRate) {
		sText.Format("%d", nIndex / m_cDataFile.m_nDownRate + 1);
		m_cListData.InsertItem(i, sText);

		CDataDateTime Begin;
		Begin.SetTime(m_cDataFile.m_dInStarttime.m_YY
			, m_cDataFile.m_dInStarttime.m_MM
			, m_cDataFile.m_dInStarttime.m_DD
			, (int)((m_nBeginTime + nIndex / m_cDataFile.m_fSampleRate) * 1000));
		sText = Begin.GetStrYMD();
		sText += CGeneral::FormatTime(m_nBeginTime + nIndex / m_cDataFile.m_fSampleRate, 4);
		m_cListData.SetItemText(i, 1, sText);

		sText.Format("%f", m_cDataFile.m_pDataX[nIndex]);
		m_cListData.SetItemText(i, 2, sText);

		sText.Format("%f", m_cDataFile.m_pDataY[nIndex]);
		m_cListData.SetItemText(i, 3, sText);

		sText.Format("%f", m_cDataFile.m_pDataZ[nIndex]);
		m_cListData.SetItemText(i, 4, sText);

		if (m_cDataFile.m_nDataType == DATA_TYPE_MMA) {
			sText.Format("%.2f", m_cDataFile.m_pTempDACM[nIndex]);
			m_cListData.SetItemText(i, 5, sText);

			sText.Format("%.2f", m_cDataFile.m_pTempX[nIndex]);
			m_cListData.SetItemText(i, 6, sText);

			sText.Format("%.2f", m_cDataFile.m_pTempY[nIndex]);
			m_cListData.SetItemText(i, 7, sText);

			sText.Format("%.2f", m_cDataFile.m_pTempZ[nIndex]);
			m_cListData.SetItemText(i, 8, sText);
		}
	}

	// ĕ`拖
	m_cListData.SetRedraw(TRUE);

	// y[Wԍ\
	m_cEditPageNo.Format("%d / %d", nPageNo, m_nPageNum);

	// OŁ^Ń{^L
	m_cButtonPrevPage.EnableWindow(m_nPageNo > 1);
	m_cButtonNextPage.EnableWindow(m_nPageNo < m_nPageNum);
}

//*****************************************************************************************************
//  1. ֐
//		CDigitalDataDlg::OnBnClickedButtonPrevPage
//----------------------------------------------------------------------------------------------------
//  2. @\
//		OŃ{^NbN
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CDigitalDataDlg::OnBnClickedButtonPrevPage()
{
	if (m_nPageNo > 1)
		DispData(m_nPageNo - 1);
}

//*****************************************************************************************************
//  1. ֐
//		CDigitalDataDlg::OnBnClickedButtonNextPage
//----------------------------------------------------------------------------------------------------
//  2. @\
//		Ń{^NbN
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CDigitalDataDlg::OnBnClickedButtonNextPage()
{
	if (m_nPageNo < m_nPageNum)
		DispData(m_nPageNo + 1);
}

//*****************************************************************************************************
//  1. ֐
//		CDigitalDataDlg::OnCbnSelchangeComboSampleRate
//----------------------------------------------------------------------------------------------------
//  2. @\
//		TvgR{{bNXIύX
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CDigitalDataDlg::OnCbnSelchangeComboSampleRate()
{
	int nIndex = m_cComboSampleRate.GetCurSel();
	if (nIndex >= 0) {
		// Ԉ[g擾
		m_cDataFile.m_nDownRate = (int)m_cComboSampleRate.GetItemData(nIndex);

		// Ot\XV
		DispData(1);
	}
}

//*****************************************************************************************************
//  1. ֐
//		CDigitalDataDlg::OnBnClickedButtonPrint
//----------------------------------------------------------------------------------------------------
//  2. @\
//		{^NbN
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CDigitalDataDlg::OnBnClickedButtonPrint()
{
	int i;

	// IĂs邩`FbN
	int nItem = m_cListData.GetItemCount();
	for (i = 0; i < nItem; i++) {
		if (m_cListData.GetItemState(i, LVIS_SELECTED))
			break;
	}
	if (i == nItem) {
		CGeneral::Alert("f[^IĂB");
		return;
	}

	CString sTitle = "fW^f[^";
	CPrintDialog dlg(FALSE);

	// Jn_CAO\
	if(dlg.DoModal() == IDOK) {
		// pCDC擾
		CDC	dc;
		dc.Attach(dlg.GetPrinterDC());

		// TCY擾
		int nWidth = dc.GetDeviceCaps(HORZRES);
		int nHeight = dc.GetDeviceCaps(VERTRES);

		// }[Wݒ
		CRect rectView(0, 0, nWidth, nHeight);
		rectView.DeflateRect(nWidth / 25, nHeight / 15, nWidth / 25, nHeight / 20);

		// DOCINFOp
		DOCINFO	docinfo;
		memset(&docinfo, 0, sizeof(docinfo));
		docinfo.cbSize  = sizeof(docinfo);
		docinfo.lpszDocName = sTitle;

		// Jn
		dc.StartDoc(&docinfo);

		// Xg
		PrintData(dc, rectView, sTitle, m_cListData);

		// I
		dc.EndDoc();
	}
}

//*****************************************************************************************************
//  1. ֐
//		CDigitalDataDlg::PrintData
//----------------------------------------------------------------------------------------------------
//  2. @\
//		Xgf[^
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		CDC			&dc				[I] foCXReLXg
//		CRect		rectView		[I] ͈
//		LPCTSTR		pTitle			[I] ^Cg
//		CLixxxtrl	&cLixxxtrl		[I] 郊XgRg[
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CDigitalDataDlg::PrintData(CDC &dc, CRect rectView, LPCTSTR pTitle, CLixxxtrl &cLixxxtrl)
{
	int i, j, k;
	int x, y;
	char textBuf[32];

	// tHg쐬
	CFont fontTitle;
	fontTitle.CreatePointFont(80, "MS UI Gothic", &dc);

	// tHgI
	CFont *pFontOrg = dc.SelectObject(&fontTitle);

	// y쐬
	CPen penBlack(PS_SOLID, 2, RGB(0, 0, 0));

	// yAuVI
	CPen *pPenOrg = dc.SelectObject(&penBlack);
	dc.SelectStockObject(NULL_BRUSH);

	// tHg̃TCY擾
	TEXTMETRIC tm;
	dc.GetTextMetrics(&tm);

	// ԃXy[Xݒ
	int nLeftSpace = tm.tmAveCharWidth / 2;
	int nTopSpace = tm.tmHeight / 4;
	int nBottomSpace = tm.tmHeight / 4;

	// Ps̍擾
	int nLineHeight = tm.tmHeight + nTopSpace + nBottomSpace;

	// IĂs擾
	CUIntArray aSelectedIndex;
	int nItem = cLixxxtrl.GetItemCount();
	for (i = 0; i < nItem; i++) {
		if (cLixxxtrl.GetItemState(i, LVIS_SELECTED))
			aSelectedIndex.Add(i);
	}
	int nLineNum = (int)aSelectedIndex.GetCount();

	// Py[W̍s擾
	int nPageLine = rectView.Height() / nLineHeight;

	// y[W擾
	int nPageNum = (nLineNum + nPageLine - 1) / nPageLine;

	// J擾
	CHeaderCtrl *pHeaderCtrl = cLixxxtrl.GetHeaderCtrl();
	int nColumnNum = pHeaderCtrl->GetItemCount();

	// SJ̍̕v擾
	HDITEM hditem;
	int nListWidth = 0;
	for (i = 0; i < nColumnNum; i++) {
		hditem.mask = HDI_WIDTH;
		pHeaderCtrl->GetItem(i, &hditem);
		nListWidth += hditem.cxy;
	}

	CString	sBegin, sEnd, sStart;
	CString	sPrTitle, sPrTitle2;

	CDataDateTime Start;
	Start.SetTime(m_cDataFile.m_dInStarttime.m_YY
		, m_cDataFile.m_dInStarttime.m_MM
		, m_cDataFile.m_dInStarttime.m_DD
		, (int)(m_cDataFile.m_fStartSecond * 1000));
	sStart = Start.GetStrYMDHMS();
	sBegin = cLixxxtrl.GetItemText(aSelectedIndex[0], 1);
	sEnd = cLixxxtrl.GetItemText(aSelectedIndex[nLineNum - 1], 1);
	sPrTitle.Format("Title:%s Jn:%s ͈:%s-%s"
		, pTitle
		, sStart, sBegin, sEnd);

	switch (m_cDataFile.m_nDataType) {
	case DATA_TYPE_MMA:
		sPrTitle2.Format("SensorID:%d SampleRate:%.2f Cutoff:%d Gain:%d ʒu:%s"
			, m_cDataFile.m_nSensorId
			, m_cDataFile.m_fSampleRate
			, m_cDataFile.m_nGain
			, m_cDataFile.m_nCutoff
			, m_cDataFile.m_SensorPos);
		break;
	case DATA_TYPE_MME:
		sPrTitle2.Format("SensorID:%d SampleRate:%g ʒu:%s"
			, m_cDataFile.m_nSensorId
			, m_cDataFile.m_fSampleRate
			, m_cDataFile.m_SensorPos);
		break;
	case DATA_TYPE_ASU:
		sPrTitle2.Format("SensorID:%d SampleRate:%g ʒu:%s"
			, m_cDataFile.m_nSensorId
			, m_cDataFile.m_fSampleRate
			, m_cDataFile.m_SensorPos);
		break;
	}

	// y[W̃[v
	int nIndex = 0;
	for (i = 0; i < nPageNum; i++) {
		y = rectView.top;

		// y[WJn
		dc.StartPage();

		// ^Cg
		PrintInfo(dc, rectView, sPrTitle, sPrTitle2);

		// wb_
		x = rectView.left;
		for (j = 0; j < nColumnNum; j++) {
			hditem.mask = HDI_WIDTH | HDI_TEXT;
			hditem.pszText = textBuf;
			hditem.cchTextMax = sizeof(textBuf);
			pHeaderCtrl->GetItem(j, &hditem);

			dc.TextOut(x + nLeftSpace, y + nTopSpace, textBuf);

			x += hditem.cxy * rectView.Width() / nListWidth;
		}
		y += nLineHeight;

		// s̃[v
		for (j = 0; j < nPageLine && nIndex < nLineNum; j++) {
			x = rectView.left;

			// J̃[v
			for (k = 0; k < nColumnNum; k++) {
				dc.TextOut(x + nLeftSpace, y + nTopSpace, cLixxxtrl.GetItemText(aSelectedIndex[nIndex], k));

				hditem.mask = HDI_WIDTH;
				pHeaderCtrl->GetItem(k, &hditem);
				x += hditem.cxy * rectView.Width() / nListWidth;
			}

			nIndex++;
			y += nLineHeight;
		}

		// r
		dc.Rectangle(rectView.left, rectView.top, rectView.right, y);
		dc.MoveTo(rectView.left, rectView.top + nLineHeight);
		dc.LineTo(rectView.right, rectView.top + nLineHeight);
		x = rectView.left;
		for (j = 0; j < nColumnNum - 1; j++) {
			hditem.mask = HDI_WIDTH;
			pHeaderCtrl->GetItem(j, &hditem);
			x += hditem.cxy * rectView.Width() / nListWidth;

			dc.MoveTo(x, rectView.top);
			dc.LineTo(x, y);
		}

		// y[WI
		dc.EndPage();
	}

	// `IuWFNg̑I
	dc.SelectObject(pFontOrg);
	dc.SelectObject(pPenOrg);
}

//*****************************************************************************************************
//  1. ֐
//		CDigitalDataDlg::PrintInfo
//----------------------------------------------------------------------------------------------------
//  2. @\
//		^Cg
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		CDC			&dc				[I] foCXReLXg
//		CRect		rectView		[I] ͈
//		LPCTSTR		pTitle			[I] ^Cg
//		LPCTSTR		pTitle2			[I] ^CgQ
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CDigitalDataDlg::PrintInfo(CDC &dc, CRect rectView, LPCTSTR pTitle, LPCTSTR pTitle2)
{
	// tHg쐬
	CFont fontTitle;
	fontTitle.CreatePointFont(80, "MS UI Gothic", &dc);

	// tHgI
	CFont *pFontOrg = dc.SelectObject(&fontTitle);

	// ^Cg̃TCY擾
	CSize sizeText = dc.GetOutputTextExtent(pTitle);

	// ^Cg
	dc.TextOut(rectView.CenterPoint().x - sizeText.cx / 2, rectView.top - sizeText.cy * 4, pTitle);
	dc.TextOut(rectView.CenterPoint().x - sizeText.cx / 2, (int)(rectView.top - sizeText.cy * 2.5), pTitle2);

	// tHg̑I
	dc.SelectObject(pFontOrg);
}

//*****************************************************************************************************
//  1. ֐
//		CDigitalDataDlg::OnBnClickedButtonSelectAll
//----------------------------------------------------------------------------------------------------
//  2. @\
//		SI{^NbN
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//*****************************************************************************************************
void CDigitalDataDlg::OnBnClickedButtonSelectAll()
{
	int nItem = m_cListData.GetItemCount();
	for (int i = 0; i < nItem; i++)
		m_cListData.SetItemState(i, LVIS_SELECTED, LVIS_SELECTED);

	m_cListData.SetFocus();
}

void CDigitalDataDlg::OnCancel()
{
	DestroyWindow();
}

//*****************************************************************************************************
//  1. ֐
//		CDigitalDataDlg::PreTranslateMessage
//----------------------------------------------------------------------------------------------------
//  2. @\
//		EBhEbZ[W
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		MSG*	pMsg			[I] MSG\̂ւ̃|C^
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		BOOL	eNX̕Ԓl̂܂ܕԂ
//*****************************************************************************************************
BOOL CDigitalDataDlg::PreTranslateMessage(MSG* pMsg)
{
	// c[`bv\邽߂̏
	switch(pMsg->message){
	case WM_LBUTTONDOWN:            
	case WM_LBUTTONUP:              
	case WM_MOUSEMOVE:
		if (m_tooltip.m_hWnd)
			m_tooltip.RelayEvent(pMsg);
		break;
	}

	return CDialogEx::PreTranslateMessage(pMsg);
}
